"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const CaptchaBoxInner = (props) => {
    const { left, right, words, id, name, data = immutable_1.default.Map(), handleBlur, handleChange, handleFocus, customOnFocus, customOnBlur, customOnChange, disabled, hideError, elementProps, } = props, value = data.get("value") || "", meta = data.get("meta") || immutable_1.default.Map(), theError = meta.get("theError"), isTouched = meta.get("isTouched"), hasError = typeof theError !== "undefined", showError = isTouched && hasError, onFocus = (event) => {
        if (typeof customOnFocus === "function") {
            customOnFocus(event, handleFocus, name);
        }
        else {
            handleFocus(name);
        }
    }, onBlur = (event) => {
        if (typeof customOnBlur === "function") {
            customOnBlur(event, handleBlur, name);
        }
        else {
            handleBlur(name);
        }
    }, onChange = (event) => {
        if (typeof customOnChange === "function") {
            customOnChange(event, handleChange, name);
        }
        else {
            handleChange(name, event.target.value);
        }
    }, theClass = `${showError ? "is-invalid" : ""} form-control`;
    return (react_1.default.createElement("div", { className: "form-group row d-flex" },
        react_1.default.createElement("label", { className: `${left ? `${left} align-self-center` : "col-md-4 text-md-end"} form-control-label align-self-center`, htmlFor: name },
            `${words.CaptchaVerify} `,
            react_1.default.createElement("i", { className: "fa fa-info-circle" })),
        react_1.default.createElement("div", { className: right ? `${right} align-self-center` : "col-md-8 align-self-center" },
            react_1.default.createElement("div", { className: "custom-class" },
                react_1.default.createElement("span", { className: "custom-control-description text-muted" }, words.CaptchaTypeNumbers),
                react_1.default.createElement("div", { className: "text-center my-1" },
                    react_1.default.createElement("img", { alt: "CaptchaBox", src: `/captcha/${id}.png` }))),
            react_1.default.createElement("input", Object.assign({ className: theClass, disabled: disabled, id: name, name: name, onBlur: onBlur, onChange: onChange, onFocus: onFocus, type: "text", value: value }, elementProps)),
            !hideError && showError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null)));
}, CaptchaBox = react_1.default.memo(CaptchaBoxInner);
exports.default = CaptchaBox;
//# sourceMappingURL=CaptchaBox.js.map