"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RawDateTemplate = void 0;
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const DateInput_1 = require("./DateInput");
const util_1 = require("./util");
const DateTemplateInner = (props) => {
    const { componentProps = immutable_1.default.Map() } = props, theError = props.data.getIn(["meta", "theError"]), hasError = typeof theError !== "undefined", { leftClass, rightClass, label } = react_1.default.useMemo(() => ((0, util_1.getTemplateInfo)(componentProps)), [componentProps]);
    return (react_1.default.createElement("div", { className: "row" },
        react_1.default.createElement("label", { className: leftClass, htmlFor: props.name }, label),
        react_1.default.createElement("div", { className: rightClass },
            react_1.default.createElement(DateInput_1.RawDateInput, Object.assign({}, props)),
            !props.hideError && hasError ? (react_1.default.createElement("div", { className: "invalid-feedback" }, theError)) : null)));
};
exports.RawDateTemplate = react_1.default.memo(DateTemplateInner);
//# sourceMappingURL=DateTemplate.js.map