"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RawNumericInput = void 0;
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const utility_1 = require("x25/utility");
const util_numeric_1 = require("./util-numeric");
const NumericInputInner = (props) => {
    const renderCount = react_1.default.useRef(0), { componentProps = immutable_1.default.Map(), customClass, name, data = immutable_1.default.Map() } = props, meta = data.get("meta") || immutable_1.default.Map(), inputValue = data.get("value") || "", theError = meta.get("theError"), isTouched = meta.get("isTouched"), currency = componentProps && componentProps.get("currency"), precision = componentProps && componentProps.get("precision") || 2, optional = componentProps && componentProps.get("optional"), formatValue = componentProps && componentProps.get("formatValue") || utility_1.formatZeroValue, hasError = typeof theError !== "undefined", showError = isTouched && hasError, theClass = `${showError ? "is-invalid" : ""} ${customClass ? customClass : ""} form-control`, [value, setValue] = react_1.default.useState(inputValue), noCurrency = (typeof currency === "undefined" || Boolean(currency) === false), valueToShow = formatValue(value, optional), updateNumericValue = (targetValue) => {
        setValue(targetValue);
        let valueToStore = targetValue;
        if ((0, util_numeric_1.isFloat)((0, util_numeric_1.floatToEnglishComma)(targetValue))) {
            valueToStore = (0, util_numeric_1.getFloatValueToStore)(targetValue);
        }
        props.handleChange(name, valueToStore);
    }, onBlur = (event) => {
        const numericHandleOnBlur = () => {
            const newValue = (0, util_numeric_1.clearFloatOnBlur)(value, precision), hasChanged = value !== newValue;
            if (hasChanged) {
                updateNumericValue(newValue);
            }
            props.handleBlur(name);
        };
        if (typeof props.customOnBlur === "function") {
            props.customOnBlur(event, numericHandleOnBlur, props.handleBlur, name);
        }
        else {
            numericHandleOnBlur();
        }
    }, onChange = (event) => {
        if (typeof props.customOnChange === "function") {
            const wrapper = () => {
                updateNumericValue(event.target.value);
            };
            props.customOnChange(event, wrapper, props.handleChange, name);
        }
        else {
            updateNumericValue(event.target.value);
        }
    }, onFocus = (event) => {
        if (typeof props.customOnFocus === "function") {
            props.customOnFocus(event, props.handleFocus, name);
        }
        else {
            props.handleFocus(name);
        }
    };
    react_1.default.useEffect(() => {
        const hasFloat = (0, util_numeric_1.isFloat)(inputValue), wasValidatedWithErrors = !hasFloat && (typeof theError === "string");
        if (hasFloat || wasValidatedWithErrors) {
            updateNumericValue(inputValue);
        }
    }, [data, theError]);
    react_1.default.useEffect(() => {
        renderCount.current += 1;
    });
    if (noCurrency) {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("span", { className: "badge text-bg-primary" }, renderCount.current),
            react_1.default.createElement("input", Object.assign({ className: theClass, disabled: props.disabled, id: name, name: name, onBlur: onBlur, onChange: onChange, onFocus: onFocus, type: props.theType, value: valueToShow }, props.elementProps)),
            !props.hideError && showError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null));
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: "input-group" },
            react_1.default.createElement("span", { className: "badge text-bg-primary input-group-text" }, renderCount.current),
            react_1.default.createElement("input", Object.assign({ className: theClass, disabled: props.disabled, id: name, name: name, onBlur: onBlur, onChange: onChange, onFocus: onFocus, type: props.theType, value: value }, props.elementProps)),
            react_1.default.createElement("span", { className: "input-group-text" }, currency)),
        !props.hideError && showError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null));
};
exports.RawNumericInput = react_1.default.memo(NumericInputInner);
//# sourceMappingURL=NumericInput.js.map