"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RawSimpleSelect = void 0;
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const words_1 = require("react-immutable-form/words");
const ImmutableListOfOptions = ({ list, valueKey, nameKey }) => (react_1.default.createElement(react_1.default.Fragment, null, list.map((current) => {
    const optionValue = current.get(valueKey), optionName = current.get(nameKey);
    return (react_1.default.createElement("option", { key: optionValue, value: optionValue }, optionName));
}))), SimpleSelectInner = (props) => {
    const { customClass, name, data = immutable_1.default.Map(), handleBlur, handleChange, handleFocus, } = props, componentProps = props.componentProps || immutable_1.default.Map(), value = props.data.get("value"), meta = data.get("meta") || immutable_1.default.Map(), theError = meta.get("theError"), isTouched = meta.get("isTouched"), onFocus = (event) => {
        if (typeof props.customOnFocus === "function") {
            props.customOnFocus(event, handleFocus, name);
        }
        else {
            handleFocus(name);
        }
    }, onBlur = (event) => {
        if (typeof props.customOnBlur === "function") {
            props.customOnBlur(event, handleBlur, name);
        }
        else {
            handleBlur(name);
        }
    }, onChange = (event) => {
        const theValue = event.target.value;
        if (typeof props.customOnChange === "function") {
            props.customOnChange(event, handleChange, name);
        }
        else {
            handleChange(name, theValue);
        }
    }, hasError = typeof theError !== "undefined", showError = isTouched && hasError, theClass = `${showError ? "is-invalid" : ""} ${customClass ? customClass : ""} form-select`, { valueKey = "value", nameKey = "name", isImmutable = false, showEmptyOption = false, } = react_1.default.useMemo(() => (componentProps === null || componentProps === void 0 ? void 0 : componentProps.toJS()) || {}, [componentProps]), list = componentProps.get("list") || immutable_1.default.List();
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("select", { className: theClass, disabled: props.disabled, id: name, name: name, onBlur: onBlur, onChange: onChange, onFocus: onFocus, value: value },
            showEmptyOption ? react_1.default.createElement("option", { value: "" }, (0, words_1.getWords)().PLEASE_SELECT_OPTION) : null,
            isImmutable ? (react_1.default.createElement(ImmutableListOfOptions, { list: list, nameKey: nameKey, valueKey: valueKey })) : (list.map(({ [valueKey]: optionValue, [nameKey]: optionName }) => (react_1.default.createElement("option", { key: optionValue, value: optionValue }, optionName))))),
        !props.hideError && showError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null));
};
exports.RawSimpleSelect = react_1.default.memo(SimpleSelectInner);
//# sourceMappingURL=SimpleSelect.js.map