"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RawSwitchInput = void 0;
const immutable_1 = __importDefault(require("immutable"));
const react_1 = __importDefault(require("react"));
const SwitchInputInner = (props) => {
    var _a, _b;
    const { customClass, name, data = immutable_1.default.Map(), handleBlur, handleChange, handleFocus } = props, renderCount = react_1.default.useRef(0), value = data.get("value"), checked = value === true, meta = data.get("meta") || immutable_1.default.Map(), theError = meta.get("theError"), onFocus = (event) => {
        if (typeof props.customOnFocus === "function") {
            props.customOnFocus(event, handleFocus, name);
        }
        else {
            handleFocus(name);
        }
    }, onBlur = (event) => {
        if (typeof props.customOnBlur === "function") {
            props.customOnBlur(event, handleBlur, name);
        }
        else {
            handleBlur(name);
        }
    }, onChange = (event) => {
        const theValue = event.target.checked === true;
        if (typeof props.customOnChange === "function") {
            props.customOnChange(event, handleChange, name);
        }
        else {
            handleChange(name, theValue);
        }
    }, hasError = typeof theError !== "undefined", theClass = `${hasError ? "is-invalid" : ""} ${customClass ? customClass : ""} form-check-input`, wrapperClassName = `form-check ${((_a = props.componentProps) === null || _a === void 0 ? void 0 : _a.get("checkbox")) ? "" : "form-switch"}`;
    react_1.default.useEffect(() => {
        renderCount.current += 1;
    });
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("span", { className: "badge text-bg-primary" }, renderCount.current),
        react_1.default.createElement("div", { className: wrapperClassName },
            react_1.default.createElement("input", Object.assign({ checked: checked, className: theClass, disabled: props.disabled, id: name, name: name, onBlur: onBlur, onChange: onChange, onFocus: onFocus, type: "checkbox", value: value }, props.elementProps)),
            react_1.default.createElement("label", { className: "form-check-label", htmlFor: name }, (_b = props.componentProps) === null || _b === void 0 ? void 0 : _b.get("label")),
            !props.hideError && hasError ? (react_1.default.createElement("span", { className: "text-danger" }, theError)) : null)));
};
exports.RawSwitchInput = react_1.default.memo(SwitchInputInner);
//# sourceMappingURL=SwitchInput.js.map